﻿function buildCommentBox(jobj, fc){
    var commentBox = document.createElement('div');
    commentBox.className = "commentBox commentBox-hover";
    //commentBox.id = jobj.p;
    
    commentBox.appendChild(buildCommentInfo(jobj.f, fc));
    commentBox.appendChild(buildCommentContent(jobj.b));
    return commentBox;
}

function buildRootCommentBox(jobj, fc, p){
    var commentBox = buildCommentBox(jobj, fc);
    commentBox.id = p;
    return commentBox;
}

function buildMidCommentBox(jobj, fc){
    var commentBox = buildCommentBox(jobj, fc);
    commentBox.className = "commentBox midOfCommentBox commentBox-hover";
    
    return commentBox;
}

function buildTopCommentBox(jobj, fc){
    var commentBox = buildCommentBox(jobj, fc);
    commentBox.className = "commentBox topCommentBox commentBox-hover";
    
    return commentBox;
}

function buildCommentInfo(an, fc){
    var commentInfo = document.createElement('div');
    commentInfo.className = "commentInfo";
    commentInfo.id = "commentInfo";
    
    var author = document.createElement('span');
    author.className = "author";
    author.innerHTML = an;
    
    var floorCount = document.createElement('span');
    floorCount.className = "floorCount";
    floorCount.innerHTML = fc;
    
    commentInfo.appendChild(author);
    commentInfo.appendChild(floorCount);
    
    return commentInfo;
}

function buildCommentContent(c){
    var content = document.createElement('p');
    content.className = "content";
    content.innerHTML = c;
    
    return content;
}

//楼层隐藏操作
function setHideTips(id){
    var hideTips = document.createElement('p');
    hideTips.className = "commentBox";
    
    var content = document.createElement('p');
    content.className = "hideTips";
    content.innerText = "查看隐藏楼层";
    content.onclick = function(){
        content.innerText = "正在打开隐藏楼层...";
        expand = true;
        startWholeCommentTask(id);
    };
    
    hideTips.appendChild(content);
    return hideTips;
}


function over(obj){
    var showmore = document.getElementById('showmore');
    showmore.innerText = "正在加载...";
    
    if (window.vopenhd) {
        window.vopenhd.startCommentMoreTask();
    }
    
}

function getPtCount(){
    var length = 0;
    if (window.vopenhd) {
        length = window.vopenhd.getPtCount();
    }
    return length;
}

function getPrCount(){
    var length = 0;
    if (window.vopenhd) {
        length = window.vopenhd.getPrCount();
    }
    return length;
}

function getCommentHideConditionNum(){
    var length = 0;
    if (window.vopenhd) {
        length = window.vopenhd.getCommentHideConditionNum();
    }
    return length;
}

function getCommentTopHideNum(){
    var length = 0;
    if (window.vopenhd) {
        length = window.vopenhd.getCommentTopHideNum();
    }
    return length;
}

function getCommentBottomHideNum(){
    var length = 0;
    if (window.vopenhd) {
        length = window.vopenhd.getCommentBottomHideNum();
    }
    return length;
}

var hideConditionNum;
var topHideNum;
var bottomHideNum;
function initHideNums() {
	hideConditionNum = getCommentHideConditionNum();
	topHideNum = getCommentTopHideNum();
	bottomHideNum = getCommentBottomHideNum();
}

function getHotNonValue(index){
    var length = 0;
    if (window.vopenhd) {
        length = window.vopenhd.getHotNonValue(index);
    }
    return length;
}

function getLatestNonValue(index){
    var length = 0;
    if (window.vopenhd) {
        length = window.vopenhd.getLatestNonValue(index);
    }
    return length;
}

function getHotCommentBuildingData(index){
    var jobjArray;
    if (window.vopenhd) {
        jobjArray = window.vopenhd.getHotCommentBuilding(index);
    }
    return jobjArray;
}

function getLatestCommentBuildingData(index){
    var jobjArray;
    if (window.vopenhd) {
        jobjArray = window.vopenhd.getLatestCommentBuilding(index);
    }
    return jobjArray;
}

function getWholeCommentBuildingData(jobjArray, id){
    var array = eval(jobjArray);
     
    expandBuildingComment(array, id);
}

function expandBuildingComment(jobjArray, id){
	var pid = getPid(id);
    var commentBox = document.getElementById(pid);
    commentBox.removeChild(commentBox.firstChild);
    var childCommentBox;
    var box = commentBox;
    var len = jobjArray.length;

    for (var i = 2; i < len; i++) {
        childCommentBox = box.childNodes[0];
        if (i > 4) {
            if (i == len - 1) {
                box.insertBefore(buildTopCommentBox(jobjArray[i], len - i), childCommentBox);
            }
            else {
                box.insertBefore(buildMidCommentBox(jobjArray[i], len - i), childCommentBox);
            }
        }
        else {
            box.insertBefore(buildCommentBox(jobjArray[i], len - i), childCommentBox);
            box = box.childNodes[0];
        }
    }
    
}

function getPid(pString){
	print(pString);
    var p;
    if (pString.indexOf('_') != -1) 
        p = pString.split('_')[1];
	else p = pString;
	print(p);
	return p;
}

//跟贴盖楼
function getCommentBuilding(jobjArray, non){
    var num = jobjArray.length;
    if (num < 2) 
        return document.createElement('div');
    
    var nonValue = 0;
    if (non > 0) 
        nonValue = non - topHideNum - bottomHideNum;
    var commentBox = buildRootCommentBox(jobjArray[1], num - 1 + nonValue, jobjArray[0].p);
    var childCommentBox;
    var box = commentBox;
    for (var i = 2; i < num; i++) {
        childCommentBox = box.childNodes[0];
        if (non > 0) {
            if (i == topHideNum) {            
                box.insertBefore(setHideTips(getPid(jobjArray[0].p)), childCommentBox);
                box = box.childNodes[0];
            }
            if (i == num - 1) {
                box.insertBefore(buildTopCommentBox(jobjArray[i], num - i), childCommentBox);
            }
            else 
                if (i >= topHideNum) {
                    box.insertBefore(buildMidCommentBox(jobjArray[i], num - i), box.childNodes[0]);
                }
            
        }
        else {
            if (i > 4) {
                if (i == num - 1) {
                    box.insertBefore(buildTopCommentBox(jobjArray[i], num - i), childCommentBox);
                }
                else {
                    box.insertBefore(buildMidCommentBox(jobjArray[i], num - i), childCommentBox);
                }
            }
            else {
                box.insertBefore(buildCommentBox(jobjArray[i], num - i), childCommentBox);
                box = box.childNodes[0];
            }
        }
    }
    
    return commentBox;
}


function startWholeCommentTask(id){
    if (window.vopenhd) {
        window.vopenhd.startWholeCommentTask(id);
    }
}

function showToolBar(vnum, p, b){
    if (window.vopenhd) {
        window.vopenhd.showToolBar(vnum, p, b);
    }
}

function upVote(vnum, p){
		print("upVote v is "+vnum);
	    print("upVote p is "+p);
    voteArray[p] = vnum;
}

var expand = false;
var voteArray = {};
//构建丄1�7栋完整的跟贴楄1�7
function buildComments(jobjArray, non){
    if (jobjArray == null || jobjArray.length == 0) 
        return;
    
    var comment = document.createElement('div');
    comment.className = "inner";
	
	var v = jobjArray[0].v;
	var p = jobjArray[0].p;
	var b = jobjArray[0].b;
	
	voteArray[p] = v;

	comment.onclick = function(){
		print("v is "+v);
	    print("p is "+p);
		if(!expand) {		    
		    showToolBar(voteArray[p], p, b);
		} else {
		   expand = false;
		}
    };
    
    var para = document.createElement('p');
    para.className = "inner-para";
    
    var author = document.createElement('span');
    author.className = "from-logon";
    author.innerHTML = jobjArray[0].f;
    
    var posttime = document.createElement('span');
    posttime.className = "postTime";
    posttime.innerHTML = jobjArray[0].t;
    
    var body = document.createElement('div');
    body.className = "commentcontent";
    
    var commentBox = getCommentBuilding(jobjArray, non);
    
    var content = document.createElement('p');
    content.className = "content";
    content.innerHTML = jobjArray[0].b;
    
    var divider = document.createElement('div');
    divider.className = "line_divider";
    
    para.appendChild(author);
    para.appendChild(posttime);
    comment.appendChild(para);
    body.appendChild(commentBox);
    body.appendChild(content);
    comment.appendChild(body);
    comment.appendChild(divider);
    document.body.appendChild(comment);
}

function print(text){
    if (window.vopenhd) {
        window.vopenhd.print(text);
    }
}

function getLatestBody(count){
    var jobjArray;
    var non = 0;
    for (var i = 0; i < count; i++) {
        jobjArray = eval("("+getLatestCommentBuildingData(i)+")");
        non = getLatestNonValue(i);
        buildComments(jobjArray, non);
    }
    //getMore();
}

function getHotBody(count){
    var jobjArray;
    var non = 0;
    for (var i = 0; i < count; i++) {
        jobjArray = eval("("+getHotCommentBuildingData(i)+")");
        non = getHotNonValue(i);
        buildComments(jobjArray, non);
    }
}

function startCommentTask(type){
    if (window.vopenhd) {
        window.vopenhd.startCommentTask(type);
    }
}

function initialize(){
	initHideNums();
    var loadtext = document.createElement('div');
    loadtext.innerText = "";
    loadtext.id = "load_text";
	document.body.className = "body";
    document.body.appendChild(loadtext);
}

function notifyNoComment(){
    var loadtext = document.getElementById('load_text');
    //loadtext.innerText = "无跟贴数捄1�7";
    loadtext.innerText = "";
}

function removeLoadText(){
    document.body.removeChild(document.getElementById("load_text"));
}
