(function() {
	if (window.OpenCourseJSBridge) {
		return;
	}
	var _callback_count = 1000;
	var _callback_map = {};
	var _webFunctions = {};
	window.OpenCourseJSBridge = {
		invoke : function(func, params, callback) {
			if (!func || typeof func !== "string") {
				return
			}
			if (typeof params === "object") {
				params = JSON.stringify(params)
			} else {
				if (params === undefined || params === null) {
					params = ""
				} else{
				   params = params.toString();
				}
			}
			var callbackId = (_callback_count++).toString();
			if (typeof callback === "function") {
				_callback_map[callbackId] = callback
			}
            var __JSBridgeIframe__ = document.createElement("iframe");
            __JSBridgeIframe__.id = "__JSBridgeIframe__" + callbackId;
            __JSBridgeIframe__.style.display = "none";
            document.documentElement.appendChild(__JSBridgeIframe__);
			__JSBridgeIframe__.src = "opencourse://jsbridge/call/" + func
					+ "/" + callbackId + "/"
					+ encodeURIComponent(params)
		},
		on : function( name , callback ){
			if (name && typeof callback === 'function') {
				_webFunctions[name] = callback;
			}
		},
		_handleCallback : function(callbackId, params) {
			if (typeof callbackId === "string"
					&& typeof _callback_map[callbackId] === "function") {
				_callback_map[callbackId](params);
				delete _callback_map[callbackId]
			}
		}
		,
		_invokeWebFunction : function( name , messageString ){
			var jsonMessage;
			try{
				jsonMessage = JSON.parse(messageString);
			}catch(e){
				jsonMessage = messageString
			}
			if(name in _webFunctions){
				_webFunctions[name](jsonMessage);
			}
		}
		,
		version : "2.0"
	};
	var readyEvent = document.createEvent("Events");
	readyEvent.initEvent("OpenCourseJSBridgeReady");
	document.dispatchEvent(readyEvent)
})();